<xsl:stylesheet version="2.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" indent="yes"/>
<xsl:variable name="document" select="document('../../all_graph.osm')/osm"/>
<!--
<xsl:variable name="document" select="document('../../results/osm/all/all.osm')/osm"/>
<xsl:variable name="document" select="document('../data.osm')/osm"/>
-->
<xsl:variable name="osm" select="/osm"/>

<xsl:key name="waykey" match="way" use="tag[@k = 'ref']/@v"/>
<xsl:key name="nodekey" match="node" use="@id"/>

<xsl:template match="double">
	<xsl:variable name="malo" select="0.004"/>
	<xsl:choose>
		<xsl:when test="(abs(node[1]/@lat - node[2]/@lat) &lt; $malo) and (abs(node[1]/@lon - node[2]/@lon) &lt; $malo)">
			<true/>
		</xsl:when>
		<xsl:otherwise>
			<false/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="/osm">
	<xsl:copy>
		<xsl:copy-of select="@*"/>
		<xsl:apply-templates select="way"/>
		<xsl:copy-of select="node"/>
	</xsl:copy>
</xsl:template>

<xsl:template match="way" mode="possibleWays">
	<xsl:param name="way"/>
	<xsl:variable name="double">
		<xsl:for-each select="nd">
			<double>
				<xsl:copy-of select="key('nodekey', @ref, $document)"/>
				<xsl:variable name="position" select="position()"/>
				<xsl:copy-of select="key('nodekey', $way/nd[position() = $position]/@ref, $osm)"/>
			</double>
		</xsl:for-each>
	</xsl:variable>
	<xsl:variable name="double_r">
		<xsl:for-each select="nd">
			<double>
				<xsl:copy-of select="key('nodekey', @ref, $document)"/>
				<xsl:variable name="position" select="count($way/nd) - position() + 1"/>
				<xsl:copy-of select="key('nodekey', $way/nd[position() = $position]/@ref, $osm)"/>
			</double>
		</xsl:for-each>
	</xsl:variable>
	<xsl:variable name="similar">
		<xsl:apply-templates select="$double"/>
	</xsl:variable>
	<xsl:variable name="similar_r">
		<xsl:apply-templates select="$double_r"/>
	</xsl:variable>

	<xsl:if test="(count(nd) = count($way/nd)) and not(($similar/false) and ($similar_r/false))">
		<true/>
	</xsl:if>
</xsl:template>

<xsl:template match="way">
	<xsl:variable name="ref" select="replace(tag[@k='ref']/@v, '([0-9]+)[a-zA-Z]?','$1')"/>
	<xsl:variable name="possibleWays" select="key('waykey', $ref, $document)"/>
	<xsl:variable name="similar">
		<xsl:apply-templates select="$possibleWays" mode="possibleWays">
			<xsl:with-param name="way" select="."/>
		</xsl:apply-templates>
	</xsl:variable>
	<xsl:if test="not($similar/true)">
		<xsl:copy-of select="."/>
	</xsl:if>
</xsl:template>
</xsl:stylesheet>
